let wandItem = {Id: 271, Data: -1};
let maxHistorySize = 15;


let Selection = new CuboidRegion(null, null);
let UndoHistory = [];


function procCmd(command) {
   let cmd = command.split(" ");
   let error;

   switch(cmd[0]) {

		//HELP PAGE 1
		case "/":

			break;


		case ".s":

			break;


		case "ascend":

			break;


		case "biomeinfo":
		
			break;


		case "biomelist":
		
			break;


		case "brush":
		
			break;


		case "butcher":
		
			break;


		case "/calc":
		
			break;



		//HELP PAGE 2
		case "ceil":
		
			break;


      case "/center":
      case "/middle":
         error = false;

         if (Selection.getPos1() != null && Selection.getPos2() != null) {
            if (cmd[1] && !cmd[2]) {
               let blocks = getBlocks(cmd[1]);
               if (blocks == null) error = true;

               if (!error) {
                  let affected = center(blocks);
                  WEMessage(affected + " block(s) have been changed.");
               }
            } else if (!cmd[1]) {
               ErrMessage("Too few parameters!");
               error = true;
            } else {
           	let unused = "";
           	for (let i = 2; i < cmd.length; i++) unused += cmd[i] + " ";
               ErrMessage("Too many parameters! Unused paramters: " + unused + "null");
               error = true;
            } if (error) ErrMessage("Usage: //center <block>");
         } else ErrMessage("Make a region selection first.");
         break;


		case "/chunk":
		
			break;


		case "chunkinfo":
		
			break;


		case "clearclipboard":
		
			break;


		case "/clearhistory":
		
			break;


		case "/contract":
		
			break;


		case "/copy":
		
			break;



		//HELP PAGE 3
		case "/count":
		
			break;


		case "cs":
		
			break;


		case "/curve":
		
			break;


		case "/cut":
		
			break;


		case "cycler":
		
			break;


      case "/cyl":
         error = false;

         if (cmd[2] && !cmd[4]) {
            let position = new Vector(Math.floor(getPlayerX()), Math.floor(getPlayerY() - 1), Math.floor(getPlayerZ()));
            let radiusX;
            let radiusZ;
            let height;

            let blocks = getBlocks(cmd[1]);
            if (blocks == null) error = true;

            if (!error) {
               if (cmd[2].split(",").length == 1 && isInteger(cmd[2])) radiusX = radiusZ = parseInt(cmd[2]);
               else if (cmd[2].split(",").length == 2 && isInteger(cmd[2].split(",")[0]) && isInteger(cmd[2].split(",")[1])) {
                  radiusX = parseInt(cmd[2].split(",")[0]);
                  radiusZ = parseInt(cmd[2].split(",")[1]);
               } else {
                  if (cmd[2].split(",").length != 1 && cmd[2].split(",").length != 2)  ErrMessage("You must either specify 1 or 2 radius values.");
                  else if (!isInteger(cmd[2].split(",")[0])) ErrMessage("Number expected: string '" + cmd[2].split(",")[0] + "' given.");
                  else if (!isInteger(cmd[2].split(",")[1])) ErrMessage("Number expected: string '" + cmd[2].split(",")[1] + "' given.");
                  error = true;
               }
            }

            if (!error) {
               if (cmd[3] && (isInteger(cmd[3]) || isNegativeInteger(cmd[3]))) height = parseInt(cmd[3]);
               else if (cmd[3] && !isInteger(cmd[3]) && !isNegativeInteger(cmd[3])) {
                  ErrMessage("For paramater 'int': Expected '" + cmd[3] + "' to be a number.");
                  error = true;
               } else height = 1;
            }

            if (!error) {
               let affected = makeCylinder(position, blocks, radiusX, radiusZ, height, true);
               WEMessage(affected + " block(s) have been created.");
            }
         } else if (!cmd[2]) {
            ErrMessage("Too few parameters!");
            error = true;
         } else {
        	let unused = "";
        	for (let i = 4; i < cmd.length; i++) unused += cmd[i] + " ";
            ErrMessage("Too many parameters! Unused paramters: " + unused + "null");
            error = true;
         } if (error) ErrMessage("Usage: //cyl <block> <radius>[,<radius>] [height]");
         break;


      case "/deform":
		
         break;


		case "delchunks":
		
			break;



		//HELP PAGE 4
		case "deltree":
		
			break;


		case "descend":

			break;


		case "/distr":
		
			break;


		case "/drain":
		
			break;
			
			
      case "/edges":
         error = false;

         if (Selection.getPos1() != null && Selection.getPos2() != null) {
            if (cmd[1] && !cmd[2]) {
               let blocks = getBlocks(cmd[1]);
               if (blocks == null) error = true;

               if (!error) {
                  let affected = makeCuboidEdges(blocks);
                  WEMessage(affected + " block(s) have been changed.");
               }
            } else if (!cmd[1]) {
               ErrMessage("Too few parameters!");
               error = true;
            } else {
           	let unused = "";
           	for (let i = 2; i < cmd.length; i++) unused += cmd[i] + " ";
               ErrMessage("Too many parameters! Unused paramters: " + unused + "null");
               error = true;
            } if (error) ErrMessage("Usage: //edges <block>");
         } else ErrMessage("Make a region selection first.");
         break;


		case "/ex":
		
			break;


		case "/expand":
		
			break;


      case "/faces":
      case "/outline":
         error = false;

         if (Selection.getPos1() != null && Selection.getPos2() != null) {
            if (cmd[1] && !cmd[2]) {
               let blocks = getBlocks(cmd[1]);
               if (blocks == null) error = true;

               if (!error) {
                  let affected = makeCuboidFaces(blocks);
                  WEMessage(affected + " block(s) have been changed.");
               }
            } else if (!cmd[1]) {
               ErrMessage("Too few parameters!");
               error = true;
            } else {
           	let unused = "";
           	for (let i = 2; i < cmd.length; i++) unused += cmd[i] + " ";
               ErrMessage("Too many parameters! Unused paramters: " + unused + "null");
               error = true;
            } if (error) ErrMessage("Usage: //faces <block>");
         } else ErrMessage("Make a region selection first.");
         break;


		case "farwand":
		
			break;
			
			
			
		//HELP PAGE 5
		case "/fast":
		
			break;


		case "/fill":
		
			break;


		case "/fillr":
		
			break;


		case "/fixlava":
		
			break;


		case "/fixwater":
		
			break;


		case "/flip":
		
			break;


		case "floodfill":
		
			break;


		case "/flora":
		
			break;
			
			
			
		//HELP PAGE 6
		case "/forest":
		
			break;


		case "forestgen":
		
			break;


		case "/generate":
		
			break;


		case "/generatebiome":
		
			break;


		case "/gmask":
		
			break;


		case "/green":
		
			break;


      case "/hcyl":
         error = false;

         if (cmd[2] && !cmd[4]) {
            let position = new Vector(Math.floor(getPlayerX()), Math.floor(getPlayerY() - 1), Math.floor(getPlayerZ()));
            let radiusX;
            let radiusZ;
            let height;

            let blocks = getBlocks(cmd[1]);
            if (blocks == null) error = true;

            if (!error) {
               if (cmd[2].split(",").length == 1 && isInteger(cmd[2])) radiusX = radiusZ = parseInt(cmd[2]);
               else if (cmd[2].split(",").length == 2 && isInteger(cmd[2].split(",")[0]) && isInteger(cmd[2].split(",")[1])) {
                  radiusX = parseInt(cmd[2].split(",")[0]);
                  radiusZ = parseInt(cmd[2].split(",")[1]);
               } else {
                  if (cmd[2].split(",").length != 1 && cmd[2].split(",").length != 2)  ErrMessage("You must either specify 1 or 2 radius values.");
                  else if (!isInteger(cmd[2].split(",")[0])) ErrMessage("Number expected: string '" + cmd[2].split(",")[0] + "' given.");
                  else if (!isInteger(cmd[2].split(",")[1])) ErrMessage("Number expected: string '" + cmd[2].split(",")[1] + "' given.");
                  error = true;
               }
            }

            if (!error) {
               if (cmd[3] && (isInteger(cmd[3]) || isNegativeInteger(cmd[3]))) height = parseInt(cmd[3]);
               else if (cmd[3] && !isInteger(cmd[3]) && !isNegativeInteger(cmd[3])) {
                  ErrMessage("For paramater 'int': Expected '" + cmd[3] + "' to be a number.");
                  error = true;
               } else height = 1;
            }

            if (!error) {
               let affected = makeCylinder(position, blocks, radiusX, radiusZ, height, false);
               WEMessage(affected + " block(s) have been created.");
            }
         } else if (!cmd[2]) {
            ErrMessage("Too few parameters!");
            error = true;
         } else {
        	let unused = "";
        	for (let i = 4; i < cmd.length; i++) unused += cmd[i] + " ";
            ErrMessage("Too many parameters! Unused paramters: " + unused + "null");
            error = true;
         } if (error) ErrMessage("Usage: //hcyl <block> <radius>[,<radius>] [height]");
         break;


		case "/help":
		
			break;
			
			
			
		//HELP PAGE 7
      case "/hollow":
         error = false;

         if (Selection.getPos1() != null && Selection.getPos2() != null) {
            if (cmd[1] && !cmd[2]) {
               let blocks = getBlocks(cmd[1]);
               if (blocks == null) error = true;

               if (!error) {
                  let affected = hollowOutRegion(blocks);
                  WEMessage(affected + " block(s) have been changed.");
               }
            } else if (!cmd[1]) {
               ErrMessage("Too few parameters!");
               error = true;
            } else {
           	let unused = "";
           	for (let i = 2; i < cmd.length; i++) unused += cmd[i] + " ";
               ErrMessage("Too many parameters! Unused paramters: " + unused + "null");
               error = true;
            } if (error) ErrMessage("Usage: //hollow <block>");
         } else ErrMessage("Make a region selection first.");
         break;


		case "/hpos1":
		
			break;


		case "/hpos2":
		
			break;


      case "/hpyramid":
         error = false;

         if (cmd[2] && !cmd[3]) {
            let position = new Vector(Math.floor(getPlayerX()), Math.floor(getPlayerY() - 1), Math.floor(getPlayerZ()));
            let size;

            let blocks = getBlocks(cmd[1]);
            if (blocks == null) error = true;

            if (!error) {
               if (isInteger(cmd[2])) size = parseInt(cmd[2]);
               else {
                  if (!isInteger(cmd[2])) ErrMessage("Number expected: string '" + cmd[2] + "' given.");
                  error = true;
               }
            }

            if (!error) {
               let affected = makePyramid(position, blocks, size, false);
               WEMessage(affected + " block(s) have been created.");
            }
         } else if (!cmd[2]) {
            ErrMessage("Too few parameters!");
            error = true;
         } else {
        	let unused = "";
        	for (let i = 3; i < cmd.length; i++) unused += cmd[i] + " ";
            ErrMessage("Too many parameters! Unused paramters: " + unused + "null");
            error = true;
         } if (error) ErrMessage("Usage: //hpyramid <block> <size>");
         break;


      case "/hsphere":
         error = false;

         if (cmd[2] && !cmd[4]) {
            let position = new Vector(Math.floor(getPlayerX()), Math.floor(getPlayerY() - 1), Math.floor(getPlayerZ()));
            let radiusX;
            let radiusY;
            let radiusZ;

            let blocks = getBlocks(cmd[1]);
            if (blocks == null) error = true;

            if (!error) {
               if (cmd[2].split(",").length == 1 && isInteger(cmd[2])) radiusX = radiusY = radiusZ = parseInt(cmd[2]);
               else if (cmd[2].split(",").length == 3 && isInteger(cmd[2].split(",")[0]) && isInteger(cmd[2].split(",")[1]) && isInteger(cmd[2].split(",")[2])) {
                  radiusX = parseInt(cmd[2].split(",")[0]);
                  radiusY = parseInt(cmd[2].split(",")[1]);
                  radiusZ = parseInt(cmd[2].split(",")[2]);
               } else {
                  if (cmd[2].split(",").length != 1 && cmd[2].split(",").length != 3)  ErrMessage("You must either specify 1 or 3 radius values.");
                  else if (!isInteger(cmd[2].split(",")[0])) ErrMessage("Number expected: string '" + cmd[2].split(",")[0] + "' given.");
                  else if (!isInteger(cmd[2].split(",")[1])) ErrMessage("Number expected: string '" + cmd[2].split(",")[1] + "' given.");
                  else if (!isInteger(cmd[2].split(",")[2])) ErrMessage("Number expected: string '" + cmd[2].split(",")[2] + "' given.");
                  error = true;
               }
            }

            if (!error) {
               if (cmd[3]) position = position.add(0, radiusY, 0);
            }

            if (!error) {
               let affected = makeSphere(position, blocks, radiusX, radiusY, radiusZ, false);
               WEMessage(affected + " block(s) have been created.");
            }
         } else if (!cmd[2]) {
            ErrMessage("Too few parameters!");
            error = true;
         } else {
        	let unused = "";
        	for (let i = 4; i < cmd.length; i++) unused += cmd[i] + " ";
            ErrMessage("Too many parameters! Unused paramters: " + unused + "null");
            error = true;
         } if (error) ErrMessage("Usage: //hsphere <block> <radius>[,<radius>,<radius>] [raised?]");
         break;


		case "info":
		
			break;


		case "/inset":
		
			break;


		case "jumpto":
		
			break;
			
			
			
		//HELP PAGE 8
		case "/limit":
		
			break;


      case "/line":
         error = false;

         if (Selection.getPos1() != null && Selection.getPos2() != null) {
            if (cmd[1] && !cmd[3]) {
               let radius;

               let blocks = getBlocks(cmd[1]);
               if (blocks == null) error = true;

               if (!error) {
                  if (cmd[2] && isInteger(cmd[2])) radius = parseInt(cmd[2]);
                  else if (cmd[2] && !isInteger(cmd[2])) {
                     ErrMessage("Number expected: string '" + cmd[2] + "' given.");
                     error = true;
                  } else radius = 0;
               }

               if (!error) {
                  let affected = drawLine(blocks, radius, true);
                  WEMessage(affected + " block(s) have been changed.");
               }
            } else if (!cmd[1]) {
               ErrMessage("Too few parameters!");
               error = true;
            } else {
           	let unused = "";
           	for (let i = 2; i < cmd.length; i++) unused += cmd[i] + " ";
               ErrMessage("Too many parameters! Unused paramters: " + unused + "null");
               error = true;
            } if (error) ErrMessage("Usage: //line <block> [thickness]");
         } else ErrMessage("Make a region selection first.");
         break;


		case "listchunks":
		
			break;


		case "/load":
		
			break;


		case "lrbuild":
		
			break;


		case "mask":
		
			break;


		case "mat":
		
			break;


      case "/move":
         error = false;

         if (Selection.getPos1() != null && Selection.getPos2() != null) {
            if (!cmd[4]) {
               let count;
               let direction;
               let blocks;

               if (cmd[1] && isInteger(cmd[1])) count = parseInt(cmd[1]);
               else if (cmd[1] && !isInteger(cmd[1])) {
                  ErrMessage("For parameter 'range': Expected '" + cmd[1] + "' to be a number.");
                  error = true;
               } else count = 1;

               if (!error) {
                  if (cmd[2] && cmd[2] == "north" || cmd[2] == "n") direction = "n";
                  else if (cmd[2] && cmd[2] == "south" || cmd[2] == "s") direction = "s";
                  else if (cmd[2] && cmd[2] == "east" || cmd[2] == "e") direction = "e";
                  else if (cmd[2] && cmd[2] == "west" || cmd[2] == "w") direction = "w";
                  else if (cmd[2] && cmd[2] == "up" || cmd[2] == "u") direction = "u";
                  else if (cmd[2] && cmd[2] == "down" || cmd[2] == "d") direction = "d";
                  else if (cmd[2] && cmd[2] == "me" || cmd[2] == "m") {
                     if (Entity.getPitch(getPlayerEnt()) > 45) direction = "d";
                     else if (Entity.getPitch(getPlayerEnt()) < -45) direction = "u";
                     else {
                        if (Math.abs(Entity.getYaw(getPlayerEnt()) % 360) >= 315 || Math.abs(Entity.getYaw(getPlayerEnt()) % 360) < 45) direction = "s";
                        else if (Math.abs(Entity.getYaw(getPlayerEnt()) % 360) >= 45 && Math.abs(Entity.getYaw(getPlayerEnt()) % 360) < 135) direction = "w";
                        else if (Math.abs(Entity.getYaw(getPlayerEnt()) % 360) >= 135 && Math.abs(Entity.getYaw(getPlayerEnt()) % 360) < 225) direction = "n";
                        else if (Math.abs(Entity.getYaw(getPlayerEnt()) % 360) >= 225 && Math.abs(Entity.getYaw(getPlayerEnt()) % 360) < 315) direction = "e";
                     }
                  }
                  else {
                     if (cmd[2]) {
                        ErrMessage("Unknown direction: " + cmd[2]);
                        error = true;
                     } else {
                        if (Entity.getPitch(getPlayerEnt()) > 45) direction = "d";
                        else if (Entity.getPitch(getPlayerEnt()) < -45) direction = "u";
                        else {
                           if (Math.abs(Entity.getYaw(getPlayerEnt()) % 360) >= 315 || Math.abs(Entity.getYaw(getPlayerEnt()) % 360) < 45) direction = "s";
                           else if (Math.abs(Entity.getYaw(getPlayerEnt()) % 360) >= 45 && Math.abs(Entity.getYaw(getPlayerEnt()) % 360) < 135) direction = "w";
                           else if (Math.abs(Entity.getYaw(getPlayerEnt()) % 360) >= 135 && Math.abs(Entity.getYaw(getPlayerEnt()) % 360) < 225) direction = "n";
                           else if (Math.abs(Entity.getYaw(getPlayerEnt()) % 360) >= 225 && Math.abs(Entity.getYaw(getPlayerEnt()) % 360) < 315) direction = "e";
                        }
                     }
                  }
               }

               if (!error) {
                  if (cmd[3]) {
                     blocks = getBlocks(cmd[3]);
                     if (blocks == null) error = true;
                  } else blocks = [new BlockChance(0, 0, 100)];
               }

               if (!error) {
                  let affected = moveCuboidRegion(count, direction, blocks);
                  WEMessage(affected + " block(s) moved.");
               }
            } else {
           	let unused = "";
           	for (let i = 4; i < cmd.length; i++) unused += cmd[i] + " ";
               ErrMessage("Too many parameters! Unused paramters: " + unused + "null");
               error = true;
            } if (error) ErrMessage("Usage: //move [count] [direction] [leave-block]");
         } else ErrMessage("Make a region selection first.");
         break;
			
			
			
		//HELP PAGE 9
		case "/naturalize":
		
			break;


		case "none":
		
			break;


		case "/outset":
		
			break;


		case "/overlay":
		
			break;


		case "/paste":
		
			break;


		case "/pos1":
		
			break;


		case "/pos2":
		
			break;


		case "pumpkins":
		
			break;
			
			
			
		//HELP PAGE 10
      case "/pyramid":
         error = false;

         if (cmd[2] && !cmd[3]) {
            let position = new Vector(Math.floor(getPlayerX()), Math.floor(getPlayerY() - 1), Math.floor(getPlayerZ()));
            let size;

            let blocks = getBlocks(cmd[1]);
            if (blocks == null) error = true;

            if (!error) {
               if (isInteger(cmd[2])) size = parseInt(cmd[2]);
               else {
                  if (!isInteger(cmd[2])) ErrMessage("Number expected: string '" + cmd[2] + "' given.");
                  error = true;
               }
            }

            if (!error) {
               let affected = makePyramid(position, blocks, size, true);
               WEMessage(affected + " block(s) have been created.");
            }
         } else if (!cmd[2]) {
            ErrMessage("Too few parameters!");
            error = true;
         } else {
        	let unused = "";
        	for (let i = 3; i < cmd.length; i++) unused += cmd[i] + " ";
            ErrMessage("Too many parameters! Unused paramters: " + unused + "null");
            error = true;
         } if (error) ErrMessage("Usage: //pyramid <block> <size>");
         break;


		case "range":
		
			break;


		case "/redo":
		
			break;


		case "/regen":
		
			break;


		case "remove":
		
			break;


		case "/removeabove":
		
			break;


		case "/removebelow":
		
			break;


		case "/removenear":
		
			break;
			
			
			
		//HELP PAGE 11
		case "repl":
		
			break;


      case "/replace":
      case "/re":
      case "/rep":
         error = false;

         if (Selection.getPos1() != null && Selection.getPos2() != null) {
            if (cmd[1] && !cmd[3]) {
               let to = cmd[2] ? getBlocks(cmd[2]) : getBlocks(cmd[1]);
               let from = cmd[2] ? getBlocks(cmd[1]) : -1;
               if (to == null || from == null) error = true;

               if (!error) {
                  let affected = replaceBlocks(to, from);
                  WEMessage(affected + " block(s) have been replaced.");
               }
            } else if (!cmd[1]) {
               ErrMessage("Too few parameters!");
               error = true;
            } else {
           	let unused = "";
           	for (let i = 3; i < cmd.length; i++) unused += cmd[i] + " ";
               ErrMessage("Too many parameters! Unused paramters: " + unused + "null");
               error = true;
            } if (error) ErrMessage("Usage: //replace [from-block] <to-block>");
         } else ErrMessage("Make a region selection first.");
         break;


		case "/replacenear":
		
			break;


		case "restore":
		
			break;


		case "/rotate":
		
			break;


		case "/save":
		
			break;


		case "schematics":
		
			break;


		case "/searchitem":
		
			break;
			
			
			
		//HELP PAGE 12
		case "/sel":
		
			break;


      case "/set":
         error = false;

         if (Selection.getPos1() != null && Selection.getPos2() != null) {
            if (cmd[1] && !cmd[2]) {
               let blocks = getBlocks(cmd[1]);
               if (blocks == null) error = true;

               if (!error) {
                  let affected = setBlocks(blocks);
                  WEMessage(affected + " block(s) have been changed.");
               }
            } else if (!cmd[1]) {
               ErrMessage("Too few parameters!");
               error = true;
            } else {
           	let unused = "";
           	for (let i = 2; i < cmd.length; i++) unused += cmd[i] + " ";
               ErrMessage("Too many parameters! Unused paramters: " + unused + "null");
               error = true;
            } if (error) ErrMessage("Usage: //set <block>");
         } else ErrMessage("Make a region selection first.");
         break;


		case "/setbiome":
		
			break;


		case "/shift":
		
			break;


		case "/size":
		
			break;


		case "size":
		
			break;


		case "/smooth":
		
			break;


		case "snapshot":
		
			break;
			
			
			
		//HELP PAGE 13
		case "/snow":
		
			break;


      case "/sphere":
         error = false;

         if (cmd[2] && !cmd[4]) {
            let position = new Vector(Math.floor(getPlayerX()), Math.floor(getPlayerY() - 1), Math.floor(getPlayerZ()));
            let radiusX;
            let radiusY;
            let radiusZ;

            let blocks = getBlocks(cmd[1]);
            if (blocks == null) error = true;

            if (!error) {
               if (cmd[2].split(",").length == 1 && isInteger(cmd[2])) radiusX = radiusY = radiusZ = parseInt(cmd[2]);
               else if (cmd[2].split(",").length == 3 && isInteger(cmd[2].split(",")[0]) && isInteger(cmd[2].split(",")[1]) && isInteger(cmd[2].split(",")[2])) {
                  radiusX = parseInt(cmd[2].split(",")[0]);
                  radiusY = parseInt(cmd[2].split(",")[1]);
                  radiusZ = parseInt(cmd[2].split(",")[2]);
               } else {
                  if (cmd[2].split(",").length != 1 && cmd[2].split(",").length != 3)  ErrMessage("You must either specify 1 or 3 radius values.");
                  else if (!isInteger(cmd[2].split(",")[0])) ErrMessage("Number expected: string '" + cmd[2].split(",")[0] + "' given.");
                  else if (!isInteger(cmd[2].split(",")[1])) ErrMessage("Number expected: string '" + cmd[2].split(",")[1] + "' given.");
                  else if (!isInteger(cmd[2].split(",")[2])) ErrMessage("Number expected: string '" + cmd[2].split(",")[2] + "' given.");
                  error = true;
               }
            }

            if (!error) {
               if (cmd[3]) position = position.add(0, radiusY, 0);
            }

            if (!error) {
               let affected = makeSphere(position, blocks, radiusX, radiusY, radiusZ, true);
               WEMessage(affected + " block(s) have been created.");
            }
         } else if (!cmd[2]) {
            ErrMessage("Too few parameters!");
            error = true;
         } else {
        	let unused = "";
        	for (let i = 4; i < cmd.length; i++) unused += cmd[i] + " ";
            ErrMessage("Too many parameters! Unused paramters: " + unused + "null");
            error = true;
         } if (error) ErrMessage("Usage: //sphere <block> <radius>[,<radius>,<radius>] [raised?]");
         break;


      case "/stack":
         error = false;

         if (Selection.getPos1() != null && Selection.getPos2() != null) {
            if (!cmd[3]) {
               let count;
               let direction;

               if (cmd[1] && isInteger(cmd[1])) count = parseInt(cmd[1]);
               else if (cmd[1] && !isInteger(cmd[1])) {
                  ErrMessage("For parameter 'range': Expected '" + cmd[1] + "' to be a number.");
                  error = true;
               } else count = 1;

               if (!error) {
                  if (cmd[2] && cmd[2] == "north" || cmd[2] == "n") direction = "n";
                  else if (cmd[2] && cmd[2] == "south" || cmd[2] == "s") direction = "s";
                  else if (cmd[2] && cmd[2] == "east" || cmd[2] == "e") direction = "e";
                  else if (cmd[2] && cmd[2] == "west" || cmd[2] == "w") direction = "w";
                  else if (cmd[2] && cmd[2] == "up" || cmd[2] == "u") direction = "u";
                  else if (cmd[2] && cmd[2] == "down" || cmd[2] == "d") direction = "d";
                  else if (cmd[2] && cmd[2] == "me" || cmd[2] == "m") {
                     if (Entity.getPitch(getPlayerEnt()) > 45) direction = "d";
                     else if (Entity.getPitch(getPlayerEnt()) < -45) direction = "u";
                     else {
                        if (Math.abs(Entity.getYaw(getPlayerEnt()) % 360) >= 315 || Math.abs(Entity.getYaw(getPlayerEnt()) % 360) < 45) direction = "s";
                        else if (Math.abs(Entity.getYaw(getPlayerEnt()) % 360) >= 45 && Math.abs(Entity.getYaw(getPlayerEnt()) % 360) < 135) direction = "w";
                        else if (Math.abs(Entity.getYaw(getPlayerEnt()) % 360) >= 135 && Math.abs(Entity.getYaw(getPlayerEnt()) % 360) < 225) direction = "n";
                        else if (Math.abs(Entity.getYaw(getPlayerEnt()) % 360) >= 225 && Math.abs(Entity.getYaw(getPlayerEnt()) % 360) < 315) direction = "e";
                     }
                  }
                  else {
                     if (cmd[2]) {
                        ErrMessage("Unknown direction: " + cmd[2]);
                        error = true;
                     } else {
                        if (Entity.getPitch(getPlayerEnt()) > 45) direction = "d";
                        else if (Entity.getPitch(getPlayerEnt()) < -45) direction = "u";
                        else {
                           if (Math.abs(Entity.getYaw(getPlayerEnt()) % 360) >= 315 || Math.abs(Entity.getYaw(getPlayerEnt()) % 360) < 45) direction = "s";
                           else if (Math.abs(Entity.getYaw(getPlayerEnt()) % 360) >= 45 && Math.abs(Entity.getYaw(getPlayerEnt()) % 360) < 135) direction = "w";
                           else if (Math.abs(Entity.getYaw(getPlayerEnt()) % 360) >= 135 && Math.abs(Entity.getYaw(getPlayerEnt()) % 360) < 225) direction = "n";
                           else if (Math.abs(Entity.getYaw(getPlayerEnt()) % 360) >= 225 && Math.abs(Entity.getYaw(getPlayerEnt()) % 360) < 315) direction = "e";
                        }
                     }
                  }
               }

               if (!error) {
                  let affected = stackCuboidRegion(count, direction);
                  WEMessage(affected + " block(s) stacked.");
               }
            } else {
           	let unused = "";
           	for (let i = 3; i < cmd.length; i++) unused += cmd[i] + " ";
               ErrMessage("Too many parameters! Unused paramters: " + unused + "null");
               error = true;
            } if (error) ErrMessage("Usage: //stack [count] [direction]");
         } else ErrMessage("Make a region selection first.");
         break;


		case "superpickaxe":
		
			break;


		case "/thaw":
		
			break;


		case "thru":
		
			break;


		case "toggleeditwand":
		
			break;


		case "/toggleplace":
		
			break;
			
			
			
		//HELP PAGE 14
		case "tool":
		
			break;


		case "tree":
		
			break;


      case "/undo":
         if (UndoHistory[UndoHistory.length - 1] != undefined) {
            for (let i = 0; i < UndoHistory[UndoHistory.length - 1].length; i++) {
            	setTile(UndoHistory[UndoHistory.length - 1][i].position.getX(), UndoHistory[UndoHistory.length - 1][i].position.getY(), UndoHistory[UndoHistory.length - 1][i].position.getZ(), UndoHistory[UndoHistory.length - 1][i].block.Id, UndoHistory[UndoHistory.length - 1][i].block.Data);
            } UndoHistory.pop();
            WEMessage("Undo successful.");
         } else ErrMessage("There is nothing left to undo.");
         break;


		case "unstuck":
		
			break;


		case "up":
		
			break;


      case "/walls":
         error = false;

         if (Selection.getPos1() != null && Selection.getPos2() != null) {
            if (cmd[1] && !cmd[2]) {
               let blocks = getBlocks(cmd[1]);
               if (blocks == null) error = true;

               if (!error) {
                  let affected = makeCuboidWalls(blocks);
                  WEMessage(affected + " block(s) have been changed.");
               }
            } else if (!cmd[1]) {
               ErrMessage("Too few parameters!");
               error = true;
            } else {
           	let unused = "";
           	for (let i = 2; i < cmd.length; i++) unused += cmd[i] + " ";
               ErrMessage("Too many parameters! Unused paramters: " + unused + "null");
               error = true;
            } if (error) ErrMessage("Usage: //walls <block>");
         } else ErrMessage("Make a region selection first.");
         break;


      case "/wand":
         Entity.setCarriedItem(getPlayerEnt(), wandItem.Id, 1, wandItem.Data == -1 ? 0 : wandItem.Data);
         WEMessage("Destroy block: select pos #1; Tap block: select pos #2");
         break;


		case "worldedit":
		
			break;

      default:
         ErrMessage("Unknown command. Type \"help\" for help.");
   }
}


function useItem (x, y, z, item, block, side, itemData, blockData) {
   if (item == wandItem.Id && (itemData == wandItem.Data || wandItem.Data == -1)) {
      preventDefault();

      let pos = Selection.getPos2();

      if (pos == null || pos.getX() != x || pos.getY() != y || pos.getZ() != z) WEMessage("Second Position set to (" + x + ".0, " + y + ".0, " + z + ".0).");

      Selection.setPos2(new Vector(x, y, z));
   }
}


function destroyBlock(x, y, z, side) {
   let item = getCarriedItem();
   let itemData = Player.getCarriedItemData();

   if (Level.getGameMode() == 1) {
      if (item == wandItem.Id && (itemData == wandItem.Data || wandItem.Data == -1)) {
         preventDefault();

         let pos = Selection.getPos1();

         if (pos == null || pos.getX() != x || pos.getY() != y || pos.getZ() != z) WEMessage("First Position set to (" + x + ".0, " + y + ".0, " + z + ".0).");

         Selection.setPos1(new Vector(x, y, z));
      }
   }
}


function startDestroyBlock(x, y, z, side) {
   let item = getCarriedItem();
   let itemData = Player.getCarriedItemData();

   if (Level.getGameMode() == 0) {
      if (item == wandItem.Id && (itemData == wandItem.Data || wandItem.Data == -1)) {
         preventDefault();

         let pos = Selection.getPos1();

         if (pos == null || pos.getX() != x || pos.getY() != y || pos.getZ() != z) WEMessage("First Position set to (" + x + ".0, " + y + ".0, " + z + ".0).");

         Selection.setPos1(new Vector(x, y, z));
      }
   }
}


function WEMessage(message) {
   clientMessage(ChatColor.DARK_PURPLE + "" + message);
}


function ErrMessage(message) {
   clientMessage(ChatColor.RED + "" + message);
}


function isString (string) {
   return typeof string == "string" || string instanceof String ? true : false;
}


function isInteger(number) {
   return /^[0-9]+$/.test(number);
}

function isNegativeInteger(number) {
   return /^-?[0-9]+$/.test(number);
}


function isBoolean (boolean) {
   return (typeof JSON.parse(boolean) == "boolean" && (JSON.parse(boolean) == true || JSON.parse(boolean) == false)) || boolean == "true" || boolean == "false" ? true : false;
}


function isArray (array) {
   return array instanceof Array && Array.isArray(array) ? true : false;
}


function CuboidRegion(pos1, pos2) {
   let region = this;

   this.pos1 = pos1;
   this.pos2 = pos2;

   this.getPos1 = function() {
      return region.pos1;
   }

   this.setPos1 = function(pos) {
      region.pos1 = pos;
   }

   this.getPos2 = function() {
      return region.pos2;
   }

   this.setPos2 = function(pos) {
      region.pos2 = pos;
   }

   this.getMinimumPoint = function() {
      return new Vector(Math.min(region.pos1.getX(), region.pos2.getX()), Math.min(region.pos1.getY(), region.pos2.getY()), Math.min(region.pos1.getZ(), region.pos2.getZ()));
   }

   this.getMaximumPoint = function() {
      return new Vector(Math.max(region.pos1.getX(), region.pos2.getX()), Math.max(region.pos1.getY(), region.pos2.getY()), Math.max(region.pos1.getZ(), region.pos2.getZ()));
   }
}


function Vector(x, y, z) {
   let vector = this;

   this.x = x;
   this.y = y;
   this.z = z;

   this.getX = function() {
      return vector.x;
   }

   this.getY = function() {
      return vector.y;
   }

   this.getZ = function() {
      return vector.z;
   }

   this.setX = function(x) {
      return new Vector(x, vector.y, vector.z);
   }

   this.setY = function(y) {
      return new Vector(vector.x, y, vector.z);
   }

   this.setZ = function(z) {
      return new Vector(vector.x, vector.y, z);
   }

   this.add = function(x, y, z) {
      return new Vector(vector.x + x, vector.y + y, vector.z + z);
   }

   this.subtract = function(x, y, z) {
      return new Vector(vector.x - x, vector.y - y, vector.z - z);
   }
}


function Block(id, data) {
   let block = this;

   this.Id = id;
   this.Data = data;
}


function BlockChance(id, data, chance) {
   let block = this;

   this.Id = id;
   this.Data = data;
   this.Chance = chance;
}


function getBlocks(string) {
   let blocks = [];

   for (let i = 0; i < string.split(",").length; i++) {
      let block = string.split(",")[i];
      let chance = 0;
      let blockTemp = block;

      if (block.split("%").length > 1) {
     	chance = block.split("%")[0];
         block = block.split("%")[1];
      }

      if (isInteger(block.split(":")[0]) && (block.split(":").length == 1 || isInteger(block.split(":")[1])) && isInteger(chance)) blocks[i] = new BlockChance(block.split(":")[0], block.split(":").length == 1 ? 0 : block.split(":")[1], chance > 0 ? chance : 100 / string.split(",").length);
      else {
         if (!isInteger(block.split(":")[0]) || !isInteger(chance)) ErrMessage("For parameter 'pattern': Can't figure out what block '" + blockTemp + "' refers to");
         else if (block.split(":").length > 1 && !isInteger(block.split(":")[1])) ErrMessage("For parameter 'pattern': Unknown data value '" + block.split(":")[1] + "'");
         return null;
      }
   } return blocks;
}


function getRandomBlockFromArray(blocks) {
   let block = blocks[Math.floor(Math.random() * blocks.length)];

   if (Math.floor(Math.random() * 100) + 1 <= block.Chance) return block;
   else return getRandomBlockFromArray(blocks);
}


function getBlock(pos) {
   return new Block(getTile(pos.getX(), pos.getY(), pos.getZ()), Level.getData(pos.getX(), pos.getY(), pos.getZ()));
}


function setBlock(pos, block, undoPos) {
   if (getBlock(pos).Id != block.Id || (getBlock(pos).Id == block.Id && getBlock(pos).Data != block.Data)) {
      UndoHistory[undoPos].push({position: pos, block: getBlock(pos)});
      setTile(pos.getX(), pos.getY(), pos.getZ(), block.Id, block.Data);
      return true;
   } return false;
}


function makeCylinder(pos, block, radiusX, radiusZ, height, filled) {
   let undoPos = UndoHistory.length;
   if (undoPos < maxHistorySize || maxHistorySize == -1) UndoHistory[undoPos] = [];
   else {
      undoPos--;
      UndoHistory.shift();
      UndoHistory[undoPos] = [];
   }
   
   let affected = 0;

   radiusX += 0.5;
   radiusZ += 0.5;

   if (height == 0) return 0;
   if (height < 0) {
      height = -height;
      pos = pos.subtract(0, height, 0);
   }

   if (pos.getY() < 0) pos = pos.setY(0);
   else if (pos.getY() + height - 1 > 255) height = 255 - pos.getY() + 1;

   let invRadiusX = 1 / radiusX;
   let invRadiusZ = 1 / radiusZ;

   let ceilRadiusX = Math.ceil(radiusX);
   let ceilRadiusZ = Math.ceil(radiusZ);

   let nextXn = 0;
   forX: for (let x = 0; x <= ceilRadiusX; ++x) {
      let xn = nextXn;
      nextXn = (x + 1) * invRadiusX;
      let nextZn = 0;
      forZ: for (let z = 0; z <= ceilRadiusZ; ++z) {
         let zn = nextZn;
         nextZn = (z + 1) * invRadiusZ;

         let distanceSq = (xn * xn) + (zn * zn);
         if (distanceSq > 1) {
            if (z == 0) break forX;
            break forZ;
         }

         if (!filled && (nextXn * nextXn) + (zn * zn) <= 1 && (xn * xn) + (nextZn * nextZn) <= 1) continue;

         for (let y = 0; y < height; ++y) {
            if (setBlock(pos.add(x, y, z), getRandomBlockFromArray(block), undoPos)) {
               ++affected;
            }

            if (setBlock(pos.add(-x, y, z), getRandomBlockFromArray(block), undoPos)) {
               ++affected;
            }

            if (setBlock(pos.add(x, y, -z), getRandomBlockFromArray(block), undoPos)) {
               ++affected;
            }

            if (setBlock(pos.add(-x, y, -z), getRandomBlockFromArray(block), undoPos)) {
               ++affected;
            }
         }
      }
   }

   return affected;
}


function makeSphere(pos, block, radiusX, radiusY, radiusZ, filled) {
   let undoPos = UndoHistory.length;
   if (undoPos < maxHistorySize || maxHistorySize == -1) UndoHistory[undoPos] = [];
   else {
      undoPos--;
      UndoHistory.shift();
      UndoHistory[undoPos] = [];
   }
   
   let affected = 0;

   radiusX += 0.5;
   radiusY += 0.5;
   radiusZ += 0.5;

   let invRadiusX = 1 / radiusX;
   let invRadiusY = 1 / radiusY;
   let invRadiusZ = 1 / radiusZ;

   let ceilRadiusX = Math.ceil(radiusX);
   let ceilRadiusY = Math.ceil(radiusY);
   let ceilRadiusZ = Math.ceil(radiusZ);

   let nextXn = 0;
   forX: for (let x = 0; x <= ceilRadiusX; ++x) {
      let xn = nextXn;
      nextXn = (x + 1) * invRadiusX;
      let nextYn = 0;
      forY: for (let y = 0; y <= ceilRadiusY; ++y) {
         let yn = nextYn;
         nextYn = (y + 1) * invRadiusY;
         let nextZn = 0;
         forZ: for (let z = 0; z <= ceilRadiusZ; ++z) {
            let zn = nextZn;
            nextZn = (z + 1) * invRadiusZ;
            
            let distanceSq = (xn * xn) + (yn * yn) + (zn * zn);
            if (distanceSq > 1) {
               if (z == 0) {
                  if (y == 0) break forX;
                  break forY;
               } break forZ;
            }

            if (!filled && (nextXn * nextXn) + (yn * yn) + (zn * zn) <= 1 && (xn * xn) + (nextYn * nextYn) + (zn * zn) <= 1 && (xn * xn) + (yn * yn) + (nextZn * nextZn) <= 1) continue;

            if (setBlock(pos.add(x, y, z), getRandomBlockFromArray(block), undoPos)) {
               ++affected;
            }

            if (setBlock(pos.add(-x, y, z), getRandomBlockFromArray(block), undoPos)) {
               ++affected;
            }

            if (setBlock(pos.add(x, -y, z), getRandomBlockFromArray(block), undoPos)) {
               ++affected;
            }

            if (setBlock(pos.add(x, y, -z), getRandomBlockFromArray(block), undoPos)) {
               ++affected;
            }

            if (setBlock(pos.add(-x, -y, z), getRandomBlockFromArray(block), undoPos)) {
               ++affected;
            }

            if (setBlock(pos.add(x, -y, -z), getRandomBlockFromArray(block), undoPos)) {
               ++affected;
            }

            if (setBlock(pos.add(-x, y, -z), getRandomBlockFromArray(block), undoPos)) {
               ++affected;
            }

            if (setBlock(pos.add(-x, -y, -z), getRandomBlockFromArray(block), undoPos)) {
               ++affected;
            }
         }
      }
   }

   return affected;
}


function makePyramid(pos, block, size, filled) {
   let undoPos = UndoHistory.length;
   if (undoPos < maxHistorySize || maxHistorySize == -1) UndoHistory[undoPos] = [];
   else {
      undoPos--;
      UndoHistory.shift();
      UndoHistory[undoPos] = [];
   }

   let affected = 0;

   let height = size;

   for (let y = 0; y <= height; ++y) {
      size--;

      for (let x = 0; x <= size; ++x) {
         for (let z = 0; z <= size; ++z) {
            if ((filled && z <= size && x <= size) || z == size || x == size) {
               if (setBlock(pos.add(x, y, z), getRandomBlockFromArray(block), undoPos)) {
                  ++affected;
               }

               if (setBlock(pos.add(-x, y, z), getRandomBlockFromArray(block), undoPos)) {
                  ++affected;
               }

               if (setBlock(pos.add(x, y, -z), getRandomBlockFromArray(block), undoPos)) {
                  ++affected;
               }

               if (setBlock(pos.add(-x, y, -z), getRandomBlockFromArray(block), undoPos)) {
                  ++affected;
               }
            }
         }
      }
   }

   return affected;
}


function center(block) {
   let undoPos = UndoHistory.length;
   if (undoPos < maxHistorySize || maxHistorySize == -1) UndoHistory[undoPos] = [];
   else {
      undoPos--;
      UndoHistory.shift();
      UndoHistory[undoPos] = [];
   }

   let affected = 0;

   for (let x = Selection.getMaximumPoint().getX(); x >= Selection.getMinimumPoint().getX(); --x) {
      for (let y = Selection.getMaximumPoint().getY(); y >= Selection.getMinimumPoint().getY(); --y) {
         for (let z = Selection.getMaximumPoint().getZ(); z >= Selection.getMinimumPoint().getZ(); --z) {
            if ((x == Math.round((Selection.getMinimumPoint().getX() + Selection.getMaximumPoint().getX()) / 2) || x == Math.floor((Selection.getMinimumPoint().getX() + Selection.getMaximumPoint().getX()) / 2)) && (y == Math.round((Selection.getMinimumPoint().getY() + Selection.getMaximumPoint().getY()) / 2) || y == Math.floor((Selection.getMinimumPoint().getY() + Selection.getMaximumPoint().getY()) / 2)) && (z == Math.round((Selection.getMinimumPoint().getZ() + Selection.getMaximumPoint().getZ()) / 2) || z == Math.floor((Selection.getMinimumPoint().getZ() + Selection.getMaximumPoint().getZ()) / 2)) && setBlock(new Vector(x, y, z), getRandomBlockFromArray(block), undoPos)) {
               ++affected;
            }
         }
      }
   }

   return affected;
(i == Math.round((Max.x + Min.x) / 2) || i == Math.floor((Max.x + Min.x) / 2)) && (j == Math.round((Max.y + Min.y) / 2) || j == Math.floor((Max.y + Min.y) / 2)) && (k == Math.round((Max.z + Min.z) / 2) || k == Math.floor((Max.z + Min.z) / 2))
}


function makeCuboidEdges(block) {
   let undoPos = UndoHistory.length;
   if (undoPos < maxHistorySize || maxHistorySize == -1) UndoHistory[undoPos] = [];
   else {
      undoPos--;
      UndoHistory.shift();
      UndoHistory[undoPos] = [];
   }

   let affected = 0;

   for (let x = Selection.getMaximumPoint().getX(); x >= Selection.getMinimumPoint().getX(); --x) {
      for (let y = Selection.getMaximumPoint().getY(); y >= Selection.getMinimumPoint().getY(); --y) {
         for (let z = Selection.getMaximumPoint().getZ(); z >= Selection.getMinimumPoint().getZ(); --z) {
            if ((((x == Selection.getMinimumPoint().getX() || x == Selection.getMaximumPoint().getX()) && (y == Selection.getMinimumPoint().getY() || y == Selection.getMaximumPoint().getY() || z == Selection.getMinimumPoint().getZ() || z == Selection.getMaximumPoint().getZ())) || ((z == Selection.getMinimumPoint().getZ() || z == Selection.getMaximumPoint().getZ()) && (y == Selection.getMinimumPoint().getY() || y == Selection.getMaximumPoint().getY() || x == Selection.getMinimumPoint().getX() || x == Selection.getMaximumPoint().getX()))) && setBlock(new Vector(x, y, z), getRandomBlockFromArray(block), undoPos)) {
               ++affected;
            }
         }
      }
   }

   return affected;
}


function makeCuboidFaces(block) {
   let undoPos = UndoHistory.length;
   if (undoPos < maxHistorySize || maxHistorySize == -1) UndoHistory[undoPos] = [];
   else {
      undoPos--;
      UndoHistory.shift();
      UndoHistory[undoPos] = [];
   }

   let affected = 0;

   for (let x = Selection.getMaximumPoint().getX(); x >= Selection.getMinimumPoint().getX(); --x) {
      for (let y = Selection.getMaximumPoint().getY(); y >= Selection.getMinimumPoint().getY(); --y) {
         for (let z = Selection.getMaximumPoint().getZ(); z >= Selection.getMinimumPoint().getZ(); --z) {
            if ((x == Selection.getMinimumPoint().getX() || x == Selection.getMaximumPoint().getX() || y == Selection.getMinimumPoint().getY() || y == Selection.getMaximumPoint().getY() || z == Selection.getMinimumPoint().getZ() || z == Selection.getMaximumPoint().getZ()) && setBlock(new Vector(x, y, z), getRandomBlockFromArray(block), undoPos)) {
               ++affected;
            }
         }
      }
   }

   return affected;
}


function hollowOutRegion(block) {
   let undoPos = UndoHistory.length;
   if (undoPos < maxHistorySize || maxHistorySize == -1) UndoHistory[undoPos] = [];
   else {
      undoPos--;
      UndoHistory.shift();
      UndoHistory[undoPos] = [];
   }

   let affected = 0;

   for (let x = Selection.getMaximumPoint().getX(); x >= Selection.getMinimumPoint().getX(); --x) {
      for (let y = Selection.getMaximumPoint().getY(); y >= Selection.getMinimumPoint().getY(); --y) {
         for (let z = Selection.getMaximumPoint().getZ(); z >= Selection.getMinimumPoint().getZ(); --z) {
            if (x != Selection.getMinimumPoint().getX() && x != Selection.getMaximumPoint().getX() && y != Selection.getMinimumPoint().getY() && y != Selection.getMaximumPoint().getY() && z != Selection.getMinimumPoint().getZ() && z != Selection.getMaximumPoint().getZ() && setBlock(new Vector(x, y, z), getRandomBlockFromArray(block), undoPos)) {
               ++affected;
            }
         }
      }
   }

   return affected;
}


function drawLine(block, radius, filled) {
   let undoPos = UndoHistory.length;
   if (undoPos < maxHistorySize || maxHistorySize == -1) UndoHistory[undoPos] = [];
   else {
      undoPos--;
      UndoHistory.shift();
      UndoHistory[undoPos] = [];
   }

   let affected = 0;

   let vset = [];
   let notdrawn = true;

   let x1 = Selection.getPos1().getX(), y1 = Selection.getPos1().getY(), z1 = Selection.getPos1().getZ();
   let x2 = Selection.getPos2().getX(), y2 = Selection.getPos2().getY(), z2 = Selection.getPos2().getZ();
   let tipx = x1, tipy = y1, tipz = z1;
   let dx = Math.abs(x2 - x1), dy = Math.abs(y2 - y1), dz = Math.abs(z2 - z1);

   if (dx + dy + dz == 0) {
      vset.push(new Vector(tipx, tipy, tipz));
      notdrawn = false;
   }

   if (Math.max(Math.max(dx, dy), dz) == dx && notdrawn) {
      for (let domstep = 0; domstep <= dx; domstep++) {
         tipx = x1 + domstep * (x2 - x1 > 0 ? 1 : -1);
         tipy = Math.round(y1 + domstep * dy / dx * (y2 - y1 > 0 ? 1 : -1));
         tipz = Math.round(z1 + domstep * dz / dx * (z2 - z1 > 0 ? 1 : -1));

         vset.push(new Vector(tipx, tipy, tipz));
      } notdrawn = false;
   }

   if (Math.max(Math.max(dx, dy), dz) == dy && notdrawn) {
      for (let domstep = 0; domstep <= dy; domstep++) {
         tipy = y1 + domstep * (y2 - y1 > 0 ? 1 : -1);
         tipx = Math.round(x1 + domstep * dx / dy * (x2 - x1 > 0 ? 1 : -1));
         tipz = Math.round(z1 + domstep * dz / dy * (z2 - z1 > 0 ? 1 : -1));

         vset.push(new Vector(tipx, tipy, tipz));
      } notdrawn = false;
   }

   if (Math.max(Math.max(dx, dy), dz) == dz && notdrawn) {
      for (let domstep = 0; domstep <= dz; domstep++) {
         tipz = z1 + domstep * (z2 - z1 > 0 ? 1 : -1);
         tipy = Math.round(y1 + domstep * dy / dz * (y2 - y1 > 0 ? 1 : -1));
         tipx = Math.round(x1 + domstep * dx / dz * (x2 - x1 > 0 ? 1 : -1));

         vset.push(new Vector(tipx, tipy, tipz));
      }  notdrawn = false;
   }

   vset = getBallooned(vset, radius);

   for (let i = 0; i < vset.length; i++) if (setBlock(vset[i], getRandomBlockFromArray(block), undoPos)) {
      ++affected;
   }

   return affected;
}


function getBallooned(vset, radius) {
   let returnset = [];
   let ceilrad = Math.ceil(radius);

   for (v of vset) {
      let tipx = v.getX(), tipy = v.getY(), tipz = v.getZ();

      for (let loopx = tipx - ceilrad; loopx <= tipx + ceilrad; loopx++) {
         for (let loopy = tipy - ceilrad; loopy <= tipy + ceilrad; loopy++) {
            for (let loopz = tipz - ceilrad; loopz <= tipz + ceilrad; loopz++) {
               if (hypot(loopx - tipx, loopy - tipy, loopz - tipz) <= radius) {
                  returnset.push(new Vector(loopx, loopy, loopz));
               }
            }
         }
      }
   } return returnset;
}


function hypot(x, y, z) {
   let sum = 0;
   sum += Math.pow(x, 2);
   sum += Math.pow(y, 2);
   sum += Math.pow(z, 2);
   return Math.sqrt(sum);
}


function moveCuboidRegion(count, direction, leaveBlock) {
   let undoPos = UndoHistory.length;
   if (undoPos < maxHistorySize || maxHistorySize == -1) UndoHistory[undoPos] = [];
   else {
      undoPos--;
      UndoHistory.shift();
      UndoHistory[undoPos] = [];
   }

   let affected = 0;
   
   let blocks = [];

   switch (direction) {
      case "n":
         count = new Vector(0, 0, -count);
         break;

      case "s":
         count = new Vector(0, 0, count);
         break;

      case "e":
         count = new Vector(count, 0, 0);
         break;

      case "w":
         count = new Vector(-count, 0, 0);
         break;

      case "u":
         count = new Vector(0, count, 0);
         break;

      case "d":
         count = new Vector(0, -count, 0);
         break;
         
      default:
         count = new Vector(0, 0, 0);
   }

   for (let x = Selection.getMaximumPoint().getX(); x >= Selection.getMinimumPoint().getX(); --x) {
      for (let y = Selection.getMaximumPoint().getY(); y >= Selection.getMinimumPoint().getY(); --y) {
         for (let z = Selection.getMaximumPoint().getZ(); z >= Selection.getMinimumPoint().getZ(); --z) {
            let block = getRandomBlockFromArray(leaveBlock);

            blocks.push({position: new Vector(x, y, z), block: getBlock(new Vector(x, y, z))});
            setTile(x, y, z, block.Id, block.Data);

            ++affected;
         }
      }
   }

   for (let block of blocks) {
      setBlock(block.position.add(count.getX(), count.getY(), count.getZ()), block.block, undoPos);
      UndoHistory[undoPos].push({position: block.position, block: block.block});
   }

   return affected;
}


function replaceBlocks(to, from) {
   let undoPos = UndoHistory.length;
   if (undoPos < maxHistorySize || maxHistorySize == -1) UndoHistory[undoPos] = [];
   else {
      undoPos--;
      UndoHistory.shift();
      UndoHistory[undoPos] = [];
   }

   let affected = 0;

   for (let x = Selection.getMaximumPoint().getX(); x >= Selection.getMinimumPoint().getX(); --x) {
      for (let y = Selection.getMaximumPoint().getY(); y >= Selection.getMinimumPoint().getY(); --y) {
         for (let z = Selection.getMaximumPoint().getZ(); z >= Selection.getMinimumPoint().getZ(); --z) {
            if (from == -1) {
               if (getBlock(new Vector(x, y, z)).Id != 0 && setBlock(new Vector(x, y, z), getRandomBlockFromArray(to), undoPos)) {
                  ++affected;
               }
            } else forFrom: for (let i = 0; i < from.length; i++) if (getBlock(new Vector(x, y, z)).Id == from[i].Id && (getBlock(new Vector(x, y, z)).Data == from[i].Data || getBlock(new Vector(x, y, z)).Data == -1) && setBlock(new Vector(x, y, z), getRandomBlockFromArray(to), undoPos)) {
               ++affected;
               break forFrom;
            }
         }
      }
   }

   return affected;
}


function setBlocks(block) {
   let undoPos = UndoHistory.length;
   if (undoPos < maxHistorySize || maxHistorySize == -1) UndoHistory[undoPos] = [];
   else {
      undoPos--;
      UndoHistory.shift();
      UndoHistory[undoPos] = [];
   }

   let affected = 0;

   for (let x = Selection.getMaximumPoint().getX(); x >= Selection.getMinimumPoint().getX(); --x) {
      for (let y = Selection.getMaximumPoint().getY(); y >= Selection.getMinimumPoint().getY(); --y) {
         for (let z = Selection.getMaximumPoint().getZ(); z >= Selection.getMinimumPoint().getZ(); --z) {
            if (setBlock(new Vector(x, y, z), getRandomBlockFromArray(block), undoPos)) {
               ++affected;
            }
         }
      }
   }

   return affected;
}


function stackCuboidRegion(count, direction) {
   let undoPos = UndoHistory.length;
   if (undoPos < maxHistorySize || maxHistorySize == -1) UndoHistory[undoPos] = [];
   else {
      undoPos--;
      UndoHistory.shift();
      UndoHistory[undoPos] = [];
   }

   let countOld = count;

   let affected = 0;

   switch (direction) {
      case "n":
         count = new Vector(0, 0, -count);
         break;

      case "s":
         count = new Vector(0, 0, count);
         break;

      case "e":
         count = new Vector(count, 0, 0);
         break;

      case "w":
         count = new Vector(-count, 0, 0);
         break;

      case "u":
         count = new Vector(0, count, 0);
         break;

      case "d":
         count = new Vector(0, -count, 0);
         break;

      default:
         count = new Vector(0, 0, 0);
   }

   for (let x = Selection.getMaximumPoint().getX(); x >= Selection.getMinimumPoint().getX(); --x) {
      for (let y = Selection.getMaximumPoint().getY(); y >= Selection.getMinimumPoint().getY(); --y) {
         for (let z = Selection.getMaximumPoint().getZ(); z >= Selection.getMinimumPoint().getZ(); --z) {
            for (let i = countOld; i > 0; --i) {
               if (count.getX() != 0) setBlock(new Vector(x, y, z).add((Selection.getMaximumPoint().getX() - Selection.getMinimumPoint().getX() + 1) * (Math.abs(count.getX()) / count.getX() * i), 0, 0), getBlock(new Vector(x, y, z)), undoPos);
               else if (count.getY() != 0) setBlock(new Vector(x, y, z).add(0, (Selection.getMaximumPoint().getY() - Selection.getMinimumPoint().getY() + 1) * (Math.abs(count.getY()) / count.getY() * i), 0), getBlock(new Vector(x, y, z)), undoPos);
               else if (count.getZ() != 0) setBlock(new Vector(x, y, z).add(0, 0, (Selection.getMaximumPoint().getZ() - Selection.getMinimumPoint().getZ() + 1) * (Math.abs(count.getZ()) / count.getZ() * i)), getBlock(new Vector(x, y, z)), undoPos);
               ++affected;
            }
         }
      }
   }

   return affected;
}


function makeCuboidWalls(block) {
   let undoPos = UndoHistory.length;
   if (undoPos < maxHistorySize || maxHistorySize == -1) UndoHistory[undoPos] = [];
   else {
      undoPos--;
      UndoHistory.shift();
      UndoHistory[undoPos] = [];
   }

   let affected = 0;

   for (let x = Selection.getMaximumPoint().getX(); x >= Selection.getMinimumPoint().getX(); --x) {
      for (let y = Selection.getMaximumPoint().getY(); y >= Selection.getMinimumPoint().getY(); --y) {
         for (let z = Selection.getMaximumPoint().getZ(); z >= Selection.getMinimumPoint().getZ(); --z) {
            if ((x == Selection.getMinimumPoint().getX() || x == Selection.getMaximumPoint().getX() || z == Selection.getMinimumPoint().getZ() || z == Selection.getMaximumPoint().getZ()) && setBlock(new Vector(x, y, z), getRandomBlockFromArray(block), undoPos)) {
               ++affected;
            }
         }
      }
   }

   return affected;
}
